


# a function to find the min of -2LLR among different cutting points of x sample at two sides

neighb <- function(sp12 = vector("numeric",2), x, true, eps){
  
  if(sp12[1] >= sp12[2] )
    stop("the first sample quantile has to be smaller than the second")
  
  n <- length(x)
  
  sortx_w <- myWdataclean2(z=x)
  
  sortedx <- sortx_w$value
  
  cx<- cumsum(sortx_w$weight/n)
  
  idex1 <- ifelse(sp12[1]==0, 1, max(which(cx <= sp12[1] )))
  idex2 <- max(which(cx <= sp12[2] ))
  
  mu <- c(sp12, true)
  
  abs <- data.frame(x1=idex1, x2=idex2)
  
  res <- eltest(c(sortedx[idex1], sortedx[idex2]), x, mu, eps)
  best <- res$'-2LLR'
  
  neg2.llr <- as.vector(best)
  ite <- TRUE
  while (ite==TRUE) {  
    neib1 <- c((idex1-1), idex2)
    if (idex1-1 > 0) {
      if ((!any(abs[,1]==neib1[1])) || (!any(which(neib1[1]==abs[,1]) 
                                             %in% which(neib1[2]==abs[,2])))){
        abs <- rbind(abs, neib1)
        res <- eltest(ab=c(sortedx[idex1-1], sortedx[idex2]), x, mu, eps)
        neg2.llr <- c(neg2.llr, res$'-2LLR')
      }
    }
    
    neib2 <- c(idex1, (idex2-1))
    if (idex2-1 > idex1) {
      if ((!any(abs[,2]==neib2[2]))||(!any(which(neib2[1]==abs[,1]) %in% which(neib2[2]==abs[,2])))){
        abs <- rbind(abs, neib2)
        res <- eltest(ab=c(sortedx[idex1], sortedx[idex2-1]), x, mu, eps)
        neg2.llr <- c(neg2.llr, res$'-2LLR')
      }
    }
    
    neib3 <- c((idex1+1), idex2)
    if (idex1+1 < idex2) {
      if ((!any(abs[,1]==neib3[1]))||(!any(which(neib3[1]==abs[, 1]) %in% which(neib3[2]==abs[,2])))){
        abs <- rbind(abs, neib3)
        res <- eltest(ab=c(sortedx[idex1 + 1], sortedx[idex2]), x, mu, eps)
        neg2.llr <- c(neg2.llr, res$'-2LLR')
      }  
    }
    
    neib4 <- c(idex1, (idex2 +1))
    if (idex2+1 < n) {
      if ((!any(abs[,2]==neib4[2]))||(!any(which(neib4[1]==abs[, 1]) %in% which(neib4[2]==abs[,2])))){
        abs <- rbind(abs, neib4)
        res <- eltest(ab=c(sortedx[idex1], sortedx[idex2 + 1]), x, mu, eps)
        neg2.llr <- c(neg2.llr, res$'-2LLR')
      }
    }
    
    neib5 <- c((idex1-1), (idex2-1))
    if ((idex1-1 > 0) & (idex2-1 > idex1)){
      if (!any(which(neib5[1]==abs[, 1]) %in% which(neib5[2]==abs[,2]))){
        abs <- rbind(abs, neib5)
        res <- eltest(ab=c(sortedx[idex1 -1], sortedx[idex2 - 1]), x, mu, eps)
        neg2.llr <- c(neg2.llr, res$'-2LLR')
      }
    }
    
    neib6 <- c((idex1-1), (idex2+1))
    if ((idex1-1 > 0) & (idex2+1 < n)){
      if (!any(which(neib6[1]==abs[, 1]) %in% which(neib6[2]==abs[,2]))){
        abs <- rbind(abs, neib6)
        res <- eltest(ab=c(sortedx[idex1 -1], sortedx[idex2 +1]), x, mu, eps)
        neg2.llr <- c(neg2.llr, res$'-2LLR')
      }
    }
    
    neib7 <- c((idex1 + 1), idex2 - 1)
    
    if (idex1+1 < idex2-1) {
      if (!any(which(neib7[1]==abs[, 1]) %in% which(neib7[2]==abs[,2]))){
        abs <- rbind(abs, neib7)
        res <- eltest(ab=c(sortedx[idex1 + 1], sortedx[idex2 - 1]), x, mu, eps)
        neg2.llr <- c(neg2.llr, res$'-2LLR')
      }
    }
    
    neib8 <- c((idex1 +1), (idex2 + 1))
    if ((idex1+1 < idex2) & (idex2+1 < n)){
      if (!any(which(neib8[1]==abs[, 1]) %in% which(neib8[2]==abs[,2]))){
        abs <- rbind(abs, neib8)
        res <- eltest(ab=c(sortedx[idex1 +1], sortedx[idex2 + 1]), x, mu, eps)
        neg2.llr <- c(neg2.llr, res$'-2LLR')
      }
    }
    
    if (min(neg2.llr)==best){
     # return(list(smallest=best, est.p.mean=neg2.llr$est.p.mean[which(neg2.llr$value==min(neg2.llr$value))]))
       return(list('-2LLR'=best, Pval = 1 - pchisq(best, df=1)))
      # print(abs)
      ite <- FALSE
    }  
    else {
      best=min(neg2.llr)
      idex1 <- abs[which(neg2.llr==best), 1]
      idex2 <- abs[which(neg2.llr==best), 2]
      ite <- TRUE
    }
  }
}


