
neighb.p.lc <- function(p, x, true, eps){
  
  n <- length(x)
  
  sortx_w <- myWdataclean2(z=x)
  
  sortedx <- sortx_w$value
  
  cx<- cumsum(sortx_w$weight/n)
  
  idex1 <- max(which(cx <= p ))
  
  mu <- c(p, true)
  
  abs <- as.vector(idex1)
  
  res <- eltest.p.lc(sortedx[idex1], x, mu, eps)
  best <- res$'-2LLR'
  
  neg2.llr <- as.vector(best)
  ite <- TRUE
  
  while (ite==TRUE) {  
    neib1 <- idex1-1
    if ((neib1 > 0) & (!any(abs==neib1))) {  
      abs <- c(abs, neib1)
      res <- eltest.p.lc(sortedx[idex1-1], x, mu, eps)
      neg2.llr <- c(neg2.llr, res$'-2LLR')
    }   
    neib2 <- idex1+1
    if ((neib2 <= n) & (!any(abs==neib2))){
      abs <- c(abs, neib2)
      res <- eltest.p.lc(sortedx[idex1 + 1], x, mu, eps)
      neg2.llr <- c(neg2.llr, res$'-2LLR')
    }     
    if (min(neg2.llr)==best){
      return(list('-2LLR'=best, Pval = 1 - pchisq(best, df=1)))
      ite <- FALSE
    }  
    else {
      best=min(neg2.llr)
      idex1 <- abs[which(neg2.llr==best)]     
      ite <- TRUE
    }
  }
}