\name{neighb.p}
\alias{neighb.p}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Empirical likelihood test for truncated mean
}
\description{
Compute the empirical likelihood ratio with the truncated mean fixed at \eqn{\mu_T}
}
\usage{
neighb.p(p, x, true, eps)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{p}{
the truncated quantile, \eqn{0 < p < 1}.
}
  \item{x}{
a random sample
}
  \item{true}{
the truncated mean to be tested
}
  \item{eps}{
a smoothing parameter
}
}
\details{
The empirical likehihood ratio test for trimmed mean at [0, p) is executed in two steps. 
First, test the hypotheses with two parameters, one of which is the nuisance parameters p. 
Second, profile out the nuisance paramter p. This function performs the second step - profiling out the nuisance paramter. 
This function seaches the minimum of the empirical likehihood ratio test statistics along the consecutive sample points. 
Since the test statistics is a piecewise constant function of the quantile for p, 
the minimum is easily found if the searching starts at the sample p-th quantile.  
}
\value{
\item{"-2LLR"}{the -2 loglikelihood ratio; approximate chi square distribution with one degree of freedom under H0}
\item{Pval}{the observed P-value by chi square approximation}
}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Yumin Zhao
}
%\note{
%%  ~~further notes~~
%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

%\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
%}
\examples{
nsize <- 50
p<- 0.89

q <- qnorm(p)

rp <- function(x){
  y <- x*dnorm(x)
  y
}
omu <- integrate(rp, lower= -Inf, upper=q)$value

x <- rnorm(nsize)
neighb.p(p, x=x, true=omu, eps=1/nsize)  
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
